---
title: 'Referer header: privacy and security concerns'
slug: 'Web/Security/Referer_header:_privacy_and_security_concerns'
tags:
  - Privacy
  - Referrer Policy
  - Security
  - referer
  - referrer
---
<p class="summary">There are privacy and security risks associated with the <a href="/en-US/docs/Web/HTTP/Headers/Referer">Referer HTTP header</a>. This article describes them, and offers advice on mitigating those risks.</p>

<h2 id="The_referrer_problem">The referrer problem</h2>

<p>The {{httpheader("Referer")}} (sic) header contains the address of the previous web page from which a link to the currently requested page was followed, which has lots of fairly innocent uses including analytics, logging, or optimized caching. However, there are more problematic uses such as tracking or stealing information, or even just side effects such as inadvertently leaking sensitive information.</p>

<p>For example, consider a "reset password" page with a social media link in a footer. If the link was followed, depending on how information was shared the social media site may receive the reset password URL and may still be able to use the shared information, potentially compromising a user's security.</p>

<p>By the same logic, an image hosted on a third party side but embedded in your page could result in sensitive information being leaked to the third party. Even if security is not compromised, the information may not be something the user wants shared.</p>

<h2 id="How_can_we_fix_this">How can we fix this?</h2>

<p>Much of this risk can be mitigated by sensible design of applications. A sensible application would remove such risks by making password reset URLs only usable for a single use, or when combined with a unique user token, and transmitting sensitive data in different ways.</p>

<p>You should use {{HTTPMethod("POST")}} rather than {{HTTPMethod("GET")}} wherever possible, to avoid passing sensitive data to other locations via URLs.</p>

<p>You should always use {{glossary("HTTPS")}} for your sites. This has many security advantages, including the fact that HTTPS sites will never transmit referer information to non-HTTPS sites. This is becoming less useful in this context now that most of the web is using HTTPS, but it is still a worthy consideration.</p>

<p>In addition, you should consider removing any third party content (e.g. social networking widgets embedded in {{htmlelement("iframe")}}) from secure areas of your website, like password reset pages, payment forms, login areas, etc.</p>

<p>You can also mitigate such risks using:</p>

<ul>
 <li>The {{httpheader("Referrer-Policy")}} header on your server to control what information is sent through the <code>Referer</code> header. Again, a directive of <code>no-referrer</code> would omit the Referer header entirely.</li>
 <li>The <code>referrerpolicy</code> attribute on HTML elements that are in danger of leaking such information (such as {{HTMLElement("img")}} and {{HTMLElement("a")}}). This can for example be set to <code>no-referrer</code> to stop the <code>Referer</code> header being sent altogether.</li>
 <li>The <code>rel</code> attribute set to <code>noreferrer</code> on HTML elements that are in danger of leaking such information (such as {{HTMLElement("img")}} and {{HTMLElement("a")}}). See <a href="/en-US/docs/Web/HTML/Link_types">Link types</a> and search for <code>noreferrer</code> for more information.</li>
 <li>The <a href="https://geekthis.net/post/hide-http-referer-headers/#exit-page-redirect">Exit page</a> technique.</li>
</ul>

<p>Security-conscious server-side frameworks tend to have built in mitigations for such problems, for example:</p>

<ul>
 <li><a href="https://docs.djangoproject.com/en/stable/topics/security/">Security in Django</a> (especially see <a href="https://docs.djangoproject.com/en/stable/topics/security/#cross-site-request-forgery-csrf-protection">Cross site request forgery (CSRF) protection</a>).</li>
 <li><a href="https://github.com/helmetjs/referrer-policy">helmetjs referrer-policy</a> — middleware for setting Referrer-Policy in Node.js/Express apps (see also <a href="https://github.com/helmetjs">helmetjs</a> for more security provisions).</li>
</ul>

<h2 id="Policy_and_requirements">Policy and requirements</h2>

<p>It would make sense to write a set of security and privacy requirements for your project team(s) that specify usage of such features to mitigate the associated risks. You should enlist the help of a web security expert to write these requirements, and consider both user needs and welfare, as well as other issues like policy and regulation enforced by legislation such as the <a href="https://ec.europa.eu/commission/priorities/justice-and-fundamental-rights/data-protection/2018-reform-eu-data-protection-rules_en">EU General Data Protection Regulation (GDPR)</a>.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://infosec.mozilla.org/guidelines/web_security.html#referrer-policy">Mozilla security team guidelines on Referrer-Policy</a></li>
</ul>
